/*
 A simple program that solve 
 a*x^2 + b*x + c = 0
*/

#include <iostream>
#include <cmath>
using namespace std ; // for the moment magic ``keyword''

int
main( /* no argument for the moment */ ) {
  double a, b, c ; // declare and instance a,b,c as double variable
  cout << "Enter a = " ;
  cin >> a ;

  cout << "Enter b = " ;
  cin >> b ;

  cout << "Enter c = " ;
  cin >> c ;

  cout << "You entered " << a << "*x^2 + " << b << "*x + " << c << '\n' ;
  
  // check if is a true quadratic
  if ( a == 0 ) {
    // the quadratic is "linear"
	if ( b == 0 ) {
	  cerr << "the quadratic is degeneted\n" ; // use error I/O object
	} else {
	  cout << "Linear case, one solution x = " << -c/b << '\n' ;
	}
  } else {
    // regular case
    // evaluate the discriminant of the quadratic
    double delta = b*b - 4*a*c ;
    if ( delta > 0 ) {
      // case 2 distinct real roots
	  delta = sqrt(delta) ;
	  double x1 = (-b+delta)/(2*a) ;
	  double x2 = (-b-delta)/(2*a) ;
	  cout << "Two real roots x1 = " << x1 << " x2 = " << x2 << '\n' ;
    } else if ( delta < 0 ) {
      // case 2 complex conjugate roots
      // case 2 distinct real roots
	  delta = sqrt(-delta) ;
	  double re = -b/(2*a) ;
	  double im = delta/(2*a) ;
	  cout << "Two complex conjugate roots:\n" 
           << " x1 = (" << re << ", " << im << ")\n"
           << " x1 = (" << re << ", " << -im << ")\n" ;
    } else {
      // double root
	  cout << "Doble root x1 = x2 = " << -b/(2*a) << '\n' ;
    }
  }
  
  return 0 ; // return 0 to the OS
}
